// EFFECTS (on/off)
//     
// 								r2_sun_shafts [0/1/2/3]
//  							r2_soft_water [on/off]
//  							r2_soft_shadows [0/1/2/3]
// SSDO									r2_ssao_mode 1
// HBAO									r2_ssao_mode 2
//  - (float32)	r2_float32 [on/off]
// Steep Parallax						r2_steep_parallax [0/1/2/3]
// Dynamic Depth Of Field				r2_dof [0/1/2/3]
//   ,   
//#define USE_IMPROVED_MBLUR		// Improved Motion Blur (Sky4CE)  !!    ?   
//#define USE_CONTRAST_FILTER		//   (LURK,  )

// PARAMETERS 
//      
/////////////////////////////////////////////////////////////
//   GodRays
	//     : r2_sun_shafts. 0 - , 1 -   (20 ), 2 -   (50 ), 3 -   (100 ).     ogse_sunshafts.h
	#define SS_HEIGHT float(0.2)			//   ,    .
	#define SS_DENSITY float(0.7)			// "" ,  ,   ,    
	#define SS_BLEND_FACTOR float(0.8)		//     .   ,   ""  ,   ""
	
/////////////////////////////////////////////////////////////
// Screen-Space Directional Occlusion
	#define SSDO_RADIUS float(0.02)			//     .  ,    ,      
	#define SSDO_BLEND_FACTOR float(1)		//  . 0 - , 1 -  .
	
/////////////////////////////////////////////////////////////
// Horizon-Based Ambient Occlusion	
	#define HBAO_NUM_STEPS int(3)			//      .  ,  
	#define HBAO_RADIUS float(0.4)			//   . 
	#define HBAO_STEP_SIZE float(10)		//  .       
	#define HBAO_ANGLE_BIAS float(0.3)		//         . ,       .
	#define HBAO_THRESHOLD float(0.02)		//   .  ,     .
	#define HBAO_BLEND_FACTOR float(1)		//  . 0 - , 1 -  .

/////////////////////////////////////////////////////////////
// improved parallax occlusion mapping
	#define POM_PARALLAX_OFFSET float(0.01)			// .  ,     .
	//#define POM_CORRECT_PERSPECTIVE
	#define POM_BRIGHTNESS_COEF float(0.25)
	#define POM_CONTRAST_COEF_Q1 float(0.6)
	#define POM_CONTRAST_COEF_Q2 float(1)
	
/////////////////////////////////////////////////////////////
// dynamic depth of field
	#define DDOF_MAXCOF_FAR	float(2.5)			//      .
	#define DDOF_MINDIST_COMMON float(15.0)		//   
	#define DDOF_MAXDIST_COMMON float(275)		//   

//	#define DDOF_CLASSIC						//    GSC
	#define DDOF_GAUSSIAN						//   
	#define DDOF_CORRECTION float (2.0)			//       
	
	// Near Field DOF
	#define DDOF_MAXNEAR float(0.7)				//     .   0.7
	#define DDOF_MINNEAR float(0.0)				//     .   0.
	#define DDOF_MAXCOF_NEAR float(7.0)			//   .   15.

	// Dynamic DOF
	#define DDOF_MINDIST_ADD float(0.5)			//     
	#define DDOF_MAXDIST_FACTOR float(4.0)		// Mindist times factor = maxdist
	#define DDOF_MINDIST float(0.0)				//     
	#define DDOF_MAXDIST float(7.0)				// ,     
	#define DDOF_MAXCOF	float(2.5)				//  .    2  5.
	#define DDOF_MAXBARRIER float(15.0)			// Focus distance at which DDOF stops rendering. Beyond this focus distance, no DDOF, only regular (distance) DOF
	#define DDOF_MAXCOF_NEAR_DDOF float (2.5)	// DDOF near field blur factor

/////////////////////////////////////////////////////////////
// zoom depth of field
	#define ZOOM_MINDIST float(0.2)	        // Minimum distance (radius) from screen center where DOF starts.
	#define ZOOM_MAXDIST float(0.7)			// Distance radius from screen center at which DOF stops rendering (beyond that value - full blur). 
	#define ZOOM_MAXCOF float(80.0)				// Blur amount at the screen border while zooming.
//	#define ZOOM_FACTOR float(10.0)				// The stepness of the blur amount raising from center to border. Good values are 10-12.
//	#define ZOOM_BARRIER float (0.0)			// (DEBUG) Distance from the screen center at which blurring starts, in relative pixels.

/////////////////////////////////////////////////////////////
// Float32 (Cook-Torrance)
	#define CT_int 1.25f						//     
	#define CT_int_in 1.25f						//     
	#define BLOOM_val 0.6h						// HDR  
	#define HDR_int 10.h						//  HDR 
	
/////////////////////////////////////////////////////////////
// improved blur
	#define IMBLUR_START_DIST float(1.0)		//   
	#define IMBLUR_FINAL_DIST float(300)		//   
	#define IMBLUR_SAMPLES int(20)				//  .  ,  
	#define IMBLUR_CLAMP float(0.01)			//   
	#define IMBLUR_SCALE_X float(-0.03)			//     X
	#define IMBLUR_SCALE_Y float(0.03)			//     Y
	#define IMBLUR_VEL_START float(0.001)		//   -  
	#define IMBLUR_VEL_FIN float(0.02)			//   -  	
	
/////////////////////////////////////////////////////////////
//  
	#define CONTRAST_FILTER_COEF float(0.4)		//  
	
	// DON'T TOUCH FOLLOWING!

// DO NOT ENABLE!///
//#define SSR_DEBUG
//#define TERMOVISION

#include "ogse_sunshafts.h"
#include "ogse_dof.h"
#include "ogse_ssdo.h"
#include "ogse_hbao.h"
#include "ogse_ssr.h"
#include "ogse_pom.h"
#include "ogse_posteffects.h"
#include "ogse_test.h"